<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

/**
 * CE_Config class
 */
class CE_Config {

  var $config_values;
  var $default_config;
  var $db_key = null;
  var $db_comment = null;

  /* ************************ */
  /* ** Constructor        ** */
  /* ************************ */

  function CE_Config($default_config = array()) {
    $this->default_config = $default_config;
  }

  /* ************************ */
  /* ** Get/Set methods    ** */
  /* ************************ */

  function getValue($key) {
      if (isset($this->config_values[$key])) {
          return $this->config_values[$key];
      }
      return null;
  }

  function setValue($key, $value) {
      $this->config_values[$key] = $value;
  }

  function getVersion() {
    if (isset($this->config_values[CE_CFG_VERSION])) {
      return $this->config_values[CE_CFG_VERSION];
    }
    return CE_VERSION;
  }

  function setDBKey($key) {
    $this->db_key = $key;
  }

  /* ************************ */
  /* ** Loading methods    ** */
  /* ************************ */

  function loadConfig() {
    if (null != $this->db_key) {
      $query = '
          SELECT value
          FROM '.CONFIG_TABLE.'
          WHERE param = \''. $this->db_key .'\'
          ;';
      $result = pwg_query($query);
      if($result) {
        $row = mysql_fetch_row($result);
        if(is_string($row[0])) {
          $this->config_values = unserialize($row[0]);
        }
      }
    }
    $this->loadDefaultConfig();
  }

  private function loadDefaultConfig() {
    foreach ($this->default_config as $key => $value) {
      if (!isset($this->config_values[$key])) {
        $this->config_values[$key] = $value;
      }
    }
  }

  /* ************************ */
  /* ** Saving  methods    ** */
  /* ************************ */

  function saveConfig() {
    if (null == $this->db_key) {
      return false;
    }

    if (!isset($this->config_values[CE_CFG_COMMENT])) {
      $this->setValue(CE_CFG_COMMENT, CE_CFG_DB_COMMENT);
    }
    $db_comment = sprintf($this->config_values[CE_CFG_COMMENT],
                          $this->db_key,
                          $this->getVersion());
    $query = '
        REPLACE INTO '.CONFIG_TABLE.'
        VALUES(
          \''. $this->db_key .'\',
          \''.serialize($this->config_values).'\',
          \''. $db_comment . '\')
        ;';
    $result = pwg_query($query);
    if($result) {
      return true;
    } else {
      return false;
    }
  }

  /* ************************ */
  /* ** Maintain  methods  ** */
  /* ************************ */

  static function install($plugin_id, $default_config = array()) {
    $config = new CE_Config($default_config);
    $config->setDBKey($plugin_id);
    $config->loadConfig();
    if (isset($default_config[CE_CFG_VERSION])) {
      // Override version
      $config->setValue(CE_CFG_VERSION, $default_config[CE_CFG_VERSION]);
    }
    if (isset($default_config[CE_CFG_COMMENT])) {
      // Override comment
      $config->setValue(CE_CFG_COMMENT, $default_config[CE_CFG_COMMENT]);
    }
    $result = $config->saveConfig();
    return $result;
  }

  static function uninstall($plugin_id) {
    $query = '
        DELETE FROM '.CONFIG_TABLE.'
        WHERE param = \'' . $plugin_id . '\'
        ;';
    $result = pwg_query($query);
    if($result) {
      return true;
    } else {
      return false;
    }
  }
}
?>